//---------------------------------------------------------------------------
//
//   Voxel2
//
//          Copyright(C) 2010-2011, Claybird
//          Under New BSD License
//
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "MQPlugin.h"
#include "voxel2.h"
#include "resource.h"

HINSTANCE g_hInstance;
BOOL Voxelize(MQDocument doc);

BOOL CALLBACK DialogProc(HWND, UINT, WPARAM, LPARAM);

//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	g_hInstance=(HINSTANCE)hModule;
    return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT void MQGetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0xB3A8500C;
	*ID      = 0x96F3BFAA;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQGetPlugInName(void)
{
	// vOC
	return "Voxel2 Ver.0.02      Copyright(C) 2010-2011, Claybird";
}

//---------------------------------------------------------------------------
//  MQGetPlugInType
//    vOC̃^CvԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT int MQGetPlugInType(void)
{
	// IuWFNgό`pvOCł
	return MQPLUGIN_TYPE_OBJECT;
}

//---------------------------------------------------------------------------
//  MQEnumString
//    |bvAbvj[ɕ\镶ԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumString(int index)
{
	switch(index){
	case 0: return "Voxel2";
	//case 1: return "Delete lines";
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQModifyObject
//    j[IꂽƂɌĂяoB
//---------------------------------------------------------------------------

MQPLUGIN_EXPORT BOOL MQModifyObject(int index, MQDocument doc)
{
	switch(index){
	case 0: return Voxelize(doc);
	//case 1: return DeleteLines(doc);
	}
	return FALSE;
}



float g_fVoxelSize=10.0f;
int g_rayAxis=-1;
BOOL g_bVertexOnly=FALSE;
BOOL g_bSurfaceOnly=FALSE;


//{NZ
BOOL Voxelize(MQDocument doc)
{
	// JgIuWFNg̎擾
	int obj_index = doc->GetCurrentObjectIndex();
	if(obj_index < 0)return FALSE;

	MQObject obj = doc->GetObject(obj_index);
	if(obj == NULL)return FALSE;

	if(DialogBox(g_hInstance, MAKEINTRESOURCE(IDD_DIALOG_CONFIG), MQ_GetWindowHandle(), DialogProc) != TRUE){
		return FALSE;
	}

	std::vector<VOXEL> voxels;
	MQPoint vMin;
	if(!divideVoxel(voxels,g_fVoxelSize,obj,g_rayAxis,vMin,g_bSurfaceOnly))return FALSE;

	//-----------

	if(voxels.empty())return FALSE;

	//{NZIuWFNg𐶐
	MQObject lpVoxelized= MQ_CreateObject();
	if(!lpVoxelized)return FALSE;

	if(g_bVertexOnly){
		//_̂
		SpawnVertices(lpVoxelized,voxels,g_fVoxelSize,vMin);
	}else{
		SpawnVoxels(lpVoxelized,voxels,g_fVoxelSize,vMin);
	}

	// IuWFNghLg֓o^
	doc->AddObject(lpVoxelized);

	return TRUE;
}

// _CAO{bNX̃R[obN֐
BOOL CALLBACK DialogProc(
	HWND hwndDlg, // handle to dialog box
	UINT uMsg, // message
	WPARAM wParam, // first message parameter
	LPARAM lParam // second message parameter
	)
{
	switch(uMsg){
	case WM_COMMAND:
		switch(LOWORD(wParam)){
		case IDOK:
			{
				char buf[64];

				//{NZTCY
				if(GetDlgItemText(hwndDlg, IDC_EDIT_VOXELSIZE, buf, sizeof(buf)) == 0) break;
				g_fVoxelSize = fabs((float)atof(buf));

				//
					 if(IsDlgButtonChecked(hwndDlg,IDC_RADIO_AXIS_AUTO))g_rayAxis=-1;
				else if(IsDlgButtonChecked(hwndDlg,IDC_RADIO_AXIS_X))g_rayAxis=0;
				else if(IsDlgButtonChecked(hwndDlg,IDC_RADIO_AXIS_Y))g_rayAxis=1;
				else if(IsDlgButtonChecked(hwndDlg,IDC_RADIO_AXIS_Z))g_rayAxis=2;

				//_̂?
				g_bVertexOnly=IsDlgButtonChecked(hwndDlg,IDC_CHECK_VERTEX_ONLY);
				//\ʂ̂?
				g_bSurfaceOnly=IsDlgButtonChecked(hwndDlg,IDC_CHECK_SURFACE_ONLY);
			}
			EndDialog(hwndDlg, TRUE);
			break;
		case IDCANCEL:
			PostMessage(hwndDlg, WM_CLOSE, 0, 0);
			break;
		}
		break;

	case WM_INITDIALOG:
		SetDlgItemText(hwndDlg, IDC_EDIT_VOXELSIZE, "10.0");
		CheckDlgButton(hwndDlg,IDC_RADIO_AXIS_AUTO,TRUE);
		return TRUE;

	case WM_CLOSE:
		EndDialog(hwndDlg, FALSE);
		break;
	}

	return FALSE;
}

 
